#include <stdio.h>

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "stm32f10x_conf.h"
#include "task.h"
#include "setup.h"

/*-----------------------------------------------------------*/

void myTask(void *params) {
  int a = 0, b = 1;
  int i;
  for (i = 0; i < 100; ++i) {
    int t;
    printf("%d\n", b);
    t = b;
    b = a + b;
    a = t;
    // bad-style delay
    for (t = 0; t < 50000; ++t);
  }

  for (;;);	 // tasks don't terminate!
}

void myTask2(void *params) {
  char *name = (char*)params;
  for (;;) {
    int t;
    printf("Task %s\n", name);
    // bad-style delay
    for (t = 0; t < 50000; ++t);
  }
}

/*
 * Entry point of program execution
 */
int main( void )
{
  prvSetupHardware();

  xTaskCreate(myTask,   // pointer to task function
              "myTask",	// name
              100,      // stack size: 100 * 4 byte
              NULL,     // parameters
              0,        // priority: number between 0 and max-priority
              NULL      // handle
              );

  xTaskCreate(myTask2,   // pointer to task function
              "myTask2", // name
              100,       // stack size: 100 * 4 byte
              "2",       // parameters
              0,         // priority: number between 0 and max-priority
              NULL       // handle
              );

  xTaskCreate(myTask2,   // pointer to task function
              "myTask3", // name
              100,       // stack size: 100 * 4 byte
              "3",       // parameters
              0,         // priority: number between 0 and max-priority
              NULL       // handle
              );

  vTaskStartScheduler();
  assert(0);
  return 0;
}
/*-----------------------------------------------------------*/
